;============================================================================;
;                                  misc.asm                                  ;
;============================================================================;
;selection                                                                   ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a5.l                                             ;
;============================================================================;
;set_apd                                                                     ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0,a1.l                                             ;
;============================================================================;
;set_password                                                                ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a1/a5.l                                          ;
;============================================================================;
;self_test                                                                   ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;
;============================================================================;
;required_libs                                                               ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d5.w,a0-a1.l                                             ;
;============================================================================;
;ressources                                                                  ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a1.l                                             ;
;============================================================================;
;lock_calc                                                                   ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;
;============================================================================;
;select_all                                                                  ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;
;============================================================================;
;deselect_all                                                                ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;
;============================================================================;
;invert_selection                                                            ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;
;============================================================================;
;change_all_selection                                                        ;
;    Input     : d7.b = 0 clear, 1 set, 2 invert                             ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;
;============================================================================;
;change_selection                                                            ;
;    Input     : d7.b = 0 clear, 1 set, 2 invert                             ;
;    Output    : void                                                        ;
;    Destroyed : d0-d2.w,a0-a2.l                                             ;
;============================================================================;
;is_selected                                                                 ;
;    Input     : d1.w = variable index                                       ;
;    Output    : void                                                        ;
;    Destroyed : d0-d1.l/a1-a2.l                                             ;
;============================================================================;
;keys                                                                        ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;
;============================================================================;
;about                                                                       ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;
;============================================================================;
;get_password                                                                ;
;    Input     : void                                                        ;
;    Output    : a0.l = address of the entered password                      ;
;                CCR (z=0 wrong password)                                    ;
;    Destroyed : d0-d3.w,a0-a1.l                                             ;
;============================================================================;
;clear_window                                                                ;
;    Input     : void                                                        ;
;    Output    : current window cleared                                      ;
;    Destroyed : d0-d4.w                                                     ;
;============================================================================;
;invert                                                                      ;
;    Input     : cursor.b                                                    ;
;    Output    : graphics                                                    ;
;    Destroyed : d0,d1,d2,d3,d4                                              ;
;============================================================================;
;refresh_indicators                                                          ;
;    Input     : void                                                        ;
;    Output    : indicators drawed                                           ;
;    Destroyed : void                                                        ;
;============================================================================;
;d0_to_string                                                                ;
;    Input     : d0.l = number to convert to string                          ;
;    Output    : a0.l = address of the string                                ;
;    Destroyed : d0.l                                                        ;
;============================================================================;
;draw_string_a0                                                              ;
;    Input     : d0.w = X                                                    ;
;              : d1.w = Y                                                    ;
;              : d3.w = font                                                 ;
;    Output    : a0.l = address of the string                                ;
;    Destroyed : a1.l                                                        ;
;============================================================================;
;draw_split_line                                                             ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d2.w                                                     ;
;============================================================================;
;save_all_screen                                                             ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d4.w                                                     ;
;============================================================================;
;restore_all_screen                                                          ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : void                                                        ;


;============================================================================;
;selection                                                                   ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a5.l                                             ;

selection
         bsr        menu\clear
         move.b     indicators_value(pc),d1
         and.b      #diamond_value+second_value,d1
         beq.s      selection\current           ; if second or diamond
         eor.b      d1,indicators_value         ; are not set, go to
         move.b     #1,indicators_clear_flag    ; selection\current
         cmp.b      #second_value+diamond_value,d1
         bne.s      selection\second

selection\second_and_diamond
         bra        invert_selection

selection\second
         cmp.b      #second_value,d1
         bne.s      selection\diamond
         bra        select_all

selection\diamond
         bra        deselect_all

selection\current                         ; has shift been released ?
         btst.b     #0,shift_flag(pc)     ; no -> exit
         bne.s      selection\exit
         move.w     cursor(pc),d4
         move.w     current(pc),d5
         move.w     d5,shift_position     ; save current into shift_position
         bra.s      selection\select

selection\test_shift
         btst.b     #select_bit,old_indicators(pc)  ; is shift pressed ?
         bne.s      selection\exit
         move.w     cursor(pc),d4
         move.w     current(pc),d5
         cmp.w      shift_position(pc),d5
         bhi.s      selection\select\below
         bcs.s      selection\select\above
         cmp.w      #338,d6
         beq.s      selection\select\below\1
         bne.s      selection\select\above\1

selection\exit
         rts

selection\select\below
         cmp.w      #344,d6
         beq.s      selection\select
selection\select\below\1
         addq.w     #1,d4
         addq.w     #1,d5
         bra.s      selection\select

selection\select\above
         cmp.w      #338,d6
         beq.s      selection\select
selection\select\above\1
         subq.w     #1,d4
         subq.w     #1,d5

selection\select
         move.w     d5,d1
         bsr        is_selected\current
         seq.b      d7                    ; variable selected ?
         and.b      #1,d7                 ; yes -> d7 = 0 (to deselect)
         seq.l      d0
         and.l      #10,d0
         lea        sprites\check(pc),a0
         lea        0(a0,d0.l),a0
         move.w     window\name_absciss(pc),d0
         subq.b     #7,d0
         move.w     #draw\y,d1
         lsl.b      #3,d4
         add.b      d4,d1
         move.w     #%1111110,d3
         jsr        graphlib::put_sprite_mask
         move.w     d5,d1
         bsr        change_selection
         tst.b      window
         bne.s      selection\exit
         bsr        uninit_mode
         bsr        unalloc_file_list
         move.w     d5,d1
         bsr        alloc_file_list\same_folder
         bsr        init_mode\window_1
         bsr        change_all_selection
         bra        init_mode\window_0

;============================================================================;
;set_apd                                                                     ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0,a1.l                                             ;

set_apd
         lea        string\set_apd(pc),a0
         move.w     #set_apd_window\width,d4
         moveq.w    #set_apd_window\height,d5
         moveq.w    #2,d6
         moveq.w    #4,d7
         bsr        dialog_window\open

         moveq.w    #3,d4
         moveq.w    #set_apd_window\bar\x,d0
         moveq.w    #set_apd_window\bar\y,d1
         move.w     #set_apd_window\bar\x+119,d2
         clr.w      d3
set_apd\draw_bar
         addq.b     #1,d1
         jsr        graphlib::horiz
         dbf.s      d4,set_apd\draw_bar
         addq.b     #1,d0
         subq.b     #1,d2
         jsr        graphlib::horiz

         move.l     #5,d0
         bsr        d0_to_string
         move.w     #set_apd_window\bar\x-1,d0
         addq.b     #2,d1
         bsr        draw_string_a0

         move.w     #600,d0
         bsr        d0_to_string
         move.w     #set_apd_window\bar\x+108,d0
         bsr        draw_string_a0

         moveq.w    #window_font,d3
         lea        string\set_apd_to(pc),a0
         moveq.w    #set_apd_window\set_apd_to\x,d0
         moveq.w    #set_apd_window\set_apd_to\y,d1
         bsr        draw_string_a0

         jsr        userlib::get_APD
         divu       #5,d0
         clr.l      d7
         move.w	    d0,d7
         lsl.w      #2,d7             ;
         add.w      d0,d7             ; mulu #5
set_apd\test_lower_bound
         cmp.w      #5,d7
         bge.s      set_apd\test_upper_bound
         moveq.w    #5,d7
set_apd\test_upper_bound
         cmp.w      #600,d7
         ble.s      set_apd\clear_cursor
         move.w     #600,d7

set_apd\clear_cursor
         moveq.w    #set_apd_window\bar\x-2,d0
         moveq.w    #set_apd_window\bar\y-4,d1
         moveq.w    #123,d2
         moveq.w    #4,d3
         moveq.w    #1,d4
         jsr        graphlib::fill

set_apd\put_cursor
         move.w     d7,d0
         divu       #5,d0
         add.b      #set_apd_window\bar\x-4,d0
         moveq.w    #set_apd_window\bar\y-4,d1
         move.b     #$FF,d3
         lea        sprites\apd_pointer(pc),a0
         jsr        graphlib::put_sprite_mask

         move.w     d7,-(a7)
         pea        string\set_apd\second(pc)
         pea        string
         jsr        tios::sprintf
         lea        10(a7),a7
         lea        string,a0
         clr.b      13(a0)

         moveq.w    #set_apd_window\second\x,d0
         moveq.w    #set_apd_window\second\y,d1
         moveq.w    #window_font,d3
         bsr        draw_string_a0

set_apd\loop
         bsr        pause
         cmp.w	    #13,d6
         beq.s      set_apd\enter
         cmp.w      #264,d6
         beq.s      set_apd\esc
         cmp.w      #337,d6
         beq.s      set_apd\right
         cmp.w      #340,d6
         beq.s      set_apd\left
         cmp.w      #4433,d6
         beq.s      set_apd\right\second
         cmp.w      #4436,d6
         beq.s      set_apd\left\second
         cmp.w      #8529,d6
         beq.s      set_apd\right\diamond
         cmp.w      #8532,d6
         beq.s      set_apd\left\diamond
         bra.s      set_apd\loop

set_apd\right
         cmp.w      #600,d7
         bge        set_apd\test_upper_bound
         addq.w     #5,d7
         bra        set_apd\put_cursor
set_apd\left
         cmp.w      #5,d7
         ble        set_apd\test_lower_bound
         subq.w     #5,d7
         bra        set_apd\put_cursor
set_apd\right\second
         add.w      #50,d7
         bra        set_apd\test_upper_bound
set_apd\left\second
         sub.w      #50,d7
         bra        set_apd\test_lower_bound
set_apd\right\diamond
         move.w     #600,d7
         bra        set_apd\clear_cursor
set_apd\left\diamond
         moveq.w    #5,d7
         bra        set_apd\clear_cursor

set_apd\enter
         move.w     d7,d0
         jsr        userlib::set_APD

set_apd\esc
         bra        dialog_window\clear

;============================================================================;
;set_password                                                                ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a1/a5.l                                          ;

set_password
         bsr        get_password
	 bne	    set_password\exit

         lea        string\set_password(pc),a0
         move.w     #set_pass_window\width,d4
         moveq.w    #set_pass_window\height,d5
         moveq.w    #1,d6
         moveq.w    #4,d7
         bsr        dialog_window\open

         move.w     #set_pass_window\confirm_input\x,d0
         moveq.w    #set_pass_window\confirm_input\y,d1
         moveq.w    #63,d4
         moveq.w    #window_font*2+8,d5
         jsr        graphlib::frame

         moveq.w    #window_font,d3
         moveq.w    #set_pass_window\confirm_pass\x,d0
         moveq.w    #set_pass_window\confirm_pass\y,d1
         lea        string\confirm_password(pc),a0
         bsr        draw_string_a0

         moveq.w    #set_pass_window\new_pass\y,d1
         lea        string\enter_new_pass(pc),a0
         bsr        draw_string_a0

         move.w     #set_pass_window\new_input\x,d0
         moveq.w    #set_pass_window\new_input\y,d1
         moveq.w    #10,d2
         bsr        input_string\empty_field

         tst.b      d2
         beq.s      set_password\clear_window_and_exit
         lea	    32(a0),a1
         move.l     (a0)+,(a1)+
         move.l     (a0)+,(a1)+
         move.w     (a0)+,(a1)+
         clr.b	    (a1)+

         bsr        wait_for_no_key
         clr.w      d6
         moveq.w    #set_pass_window\confirm_input\y,d1
         moveq.w    #10,d2
         bsr        input_string\empty_field
         bsr        wait_for_no_key

         lea	    32(a0),a1
         movem.l    a0-a1,-(a7)
   	 jsr	    tios::strcmp
         movem.l    (a7)+,a0-a1
         tst.w      d0
         bne        set_password\confirmation_failed
         lea        userlib::password,a1
         move.l	    (a0)+,(a1)+
         move.l	    (a0)+,(a1)+
         move.l	    (a0)+,(a1)+
         bra.s      set_password\clear_window_and_exit
set_password\confirmation_failed
         lea        error\confirm_failed(pc),a0
         move.b     #1,error_flag
set_password\clear_window_and_exit
         bra        dialog_window\clear
set_password\exit
         rts

;============================================================================;
;self_test                                                                   ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;

self_test
         bsr        move\go_to_top
         rts

         bsr        save_all_screen
         bsr        system\interrupts_on
         trap       #10
         bsr        system\interrupts_off
         bra        restore_all_screen

 include "filelib.asm"

;============================================================================;
;required_libs                                                               ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d5.w,a0-a1/a5.l                                             ;

required_libs
         move.b     window(pc),d0
         addq.b     #1,d0
         and.b      #2,d0
         beq        required_libs\not_asm
         bsr        get_handle\folder\current
         bsr        get_index\current
         jsr        filelib::gettype
         cmp.w      #1,d2
         bhi        required_libs\not_asm

         bsr        get_handle\current
         DEREF      d0,a5
         clr.l      d0
         move.w     (a5),d0                   ; size
         lea        1(a5,d0.l),a0             ; type
         cmp.b      #$F8,(a0)                 ; zipped ?
         beq        required_libs\zipped_file

         lea        string\required_libs(pc),a0
         moveq.w    #required_libs_window\width,d4
         moveq.w    #required_libs_window\height,d5
         clr.w      d6
         clr.w      d7
         bsr        dialog_window\open

         moveq.w    #required_libs_window\libs\x,d0
         moveq.w    #required_libs_window\libs\y,d1
         moveq.w    #window_font,d3
         clr.w      d5

         cmp.w	    #"68",6(a5)         ;
         seq.b      d6                  ;
         cmp.b	    #"k",8(a5)          ; without a kernel ?
         seq.b      d7                  ;
         and.b      d6,d7               ;
         tst.b      d7                  ;
         beq.s      required_libs\none  ;

	 lea        $1A+2(a5),a0    ; a0 points Import Table
      	 move.w     (a0)+,d4	    ; d4 = number of libs used
         subq.b     #1,d4
         cmp.b      #-1,d4
         bne.s      required_libs\loop
required_libs\none
         lea        string\none(pc),a0
         clr.w      d4
required_libs\loop
         bsr        draw_string_a0
         lea        10(a0),a0
         addq.b     #required_libs_window\libs\dy,d1
         addq.b     #1,d5
         cmp.w      #5,d5
         bne.s      required_libs\loop\dbf
         add.b      #required_libs_window\width/2,d0     ;
         sub.b      #required_libs_window\libs\dy*5,d1   ; second column
required_libs\loop\dbf
         dbf.s      d4,required_libs\loop
         bra        dialog_window\pause_and_clear

required_libs\zipped_file
         lea        error\zipped_file(pc),a0
         bra.s      required_libs\set_error_flag

required_libs\not_asm
         lea        error\not_asm(pc),a0

required_libs\set_error_flag
         move.b     #1,error_flag
         rts


;============================================================================;
;ressources                                                                  ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a1.l                                             ;

ressources
         jsr        userlib::getfreeRAM
         move.l     d0,a5                   ; save d0

         jsr        viewlib::frequency
         move.l     d0,a6                   ; save d0

         lea        string\ressources(pc),a0
         move.w     #ressources_window\width,d4
         moveq.w    #ressources_window\height,d5
         clr.w      d6
         clr.w      d7
         bsr        dialog_window\open

         lea        string\ram_free(pc),a0
         moveq.w    #ressources_window\item\x,d0
         moveq.w    #ressources_window\item\y,d1
         moveq.w    #window_font,d3
         bsr        draw_string_a0

         move.l     a5,d0
         lea        string\bytes(pc),a0
         bsr        ressources\draw_number

         lea        string\archive_free(pc),a0
         moveq.w    #ressources_window\item\x,d0
         addq.b     #ressources_window\item\dy,d1
         bsr        draw_string_a0

         jsr        userlib::getfreearchive
         lea        string\bytes(pc),a0
         bsr        ressources\draw_number

         lea        string\frequency(pc),a0
         moveq.w    #ressources_window\item\x,d0
         addq.b     #ressources_window\item\dy,d1
         bsr        draw_string_a0

         move.l     a6,d0
         bsr        ressources\draw_number\frequency

         lea        string\batteries(pc),a0
         moveq.w    #ressources_window\item\x,d0
         addq.b     #ressources_window\item\dy,d1
         bsr        draw_string_a0

         lea        sprites\batteries(pc),a0
         moveq.w    #ressources_window\value\x-1,d0
         add.b      #window_font,d1
         move.w     #$FFFF,d3
         jsr        graphlib::put_sprite_mask
         bsr        batteries_level
         mulu       #3,d2
         move.w     #ressources_window\batt\x,d0
         addq.b     #1,d1
         moveq.w    #3,d3
         moveq.w    #2,d4
         jsr        graphlib::fill

ressources\pause
         jsr        viewlib::frequency
         bsr        ressources\draw_number\frequency
         move.w     #200,d7
ressources\test
         bsr        get_key
         tst.w      d6
         dbne.s     d7,ressources\test
         beq.s      ressources\pause
         bra        dialog_window\clear

ressources\draw_number
         move.w     d1,-(a7)
         move.l     a0,-(a7)
         bsr        d0_to_string
         move.b     #' ',-(a0)
         move.b     #':',-(a0)
         move.l     a0,-(a7)
         jsr        tios::strcat
         lea        8(a7),a7
         moveq.w    #ressources_window\value\x,d0
         move.w     (a7)+,d1
         moveq.w    #window_font,d3
         bra        draw_string_a0

ressources\draw_number\frequency
         and.l      #$FFFF,d0
         mulu       #75,d0
         divu       #100,d0
         and.l      #$FFFF,d0
         divu       #100,d0
         swap       d0
         move.w     d0,d4
         clr.w      d0
         swap       d0                  ; d0.l = frequency div 100
         add.w      #5,d4               ; for rounding
         divu       #10,d4
         cmp.w      #10,d4
         bne.s      #ressources\draw_number\frequency\rounding_adjust
         clr.w      d4                  ; if rounding did a 10
         addq.w     #$1,d0
ressources\draw_number\frequency\rounding_adjust
         add.b      #48,d4
         lea        string\mega_hertz(pc),a0
         move.b     d4,1(a0)
         moveq.w    #ressources_window\item\y+2*ressources_window\item\dy,d1
         bra        ressources\draw_number

;============================================================================;
;lock_calc                                                                   ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;

lock_calc
         btst.b     #0,password_protect_flag(pc)
         bne.s      lock_calc\exit
         bsr        menu\clear
         jsr        userlib::get_APD
         move.w     d0,d5                          ; save d0
         moveq.w    #5,d0
         jsr        userlib::set_APD
	 lea        $40078,a6
	 move.l     (a6),d7
	 move.l     #system\null_interrupt_handler,(a6)

lock_calc\off
	 trap	    #4
	 bsr	    get_password
	 bne.s      lock_calc\off
	 move.l     d7,(a6)
         move.w     d5,d0
         jsr        userlib::set_APD

lock_calc\exit
         rts

;============================================================================;
;select_all                                                                  ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;

select_all
         moveq.b    #1,d7
         bra.s      change_all_selection

;============================================================================;
;deselect_all                                                                ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;

deselect_all
         clr.b      d7
         bra.s      change_all_selection

;============================================================================;
;invert_selection                                                            ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;

invert_selection
         moveq.b    #2,d7

;============================================================================;
;change_all_selection                                                        ;
;    Input     : d7.b = 0 clear, 1 set, 2 invert                             ;
;    Output    : void                                                        ;
;    Destroyed : d0.w-d5.w,a0-a3/a5.l                                        ;

change_all_selection
         clr.b      d5
         move.w     #%1111110,d3
         lea        sprites\check(pc),a3
         cmp.w      #-1,number
         beq        change_all_selection\exit

change_all_selection\window_1
         move.w     number_to_draw(pc),d4
         move.w     d4,d1
         lsl.w      #3,d1
         add.b      #draw\y,d1
         move.w     window\name_absciss(pc),d0
         subq.b     #7,d0

change_all_selection\loop
         cmp.b      #2,d7
         bne.s       change_all_selection\set_or_clear

change_all_selection\invert
         movem.w    d0-d1,-(a7)
         move.w     current(pc),d1
         sub.w      cursor(pc),d1
         add.w      d4,d1
         bsr        is_selected
         sne.l      d2
         movem.w    (a7)+,d0-d1
         bra.s      change_all_selection\put_sprite

change_all_selection\set_or_clear
         tst.b      d7
         seq.l      d2

change_all_selection\put_sprite
         and.l      #10,d2
         lea        0(a3,d2.l),a0
         jsr        graphlib::put_sprite_mask
         subq.b     #8,d1
         dbf.s      d4,change_all_selection\loop

         tst.b      window
         bne.s      change_all_selection\set_bit
         tst.b      d5
         bne.s      change_all_selection\window_0\init_mode

change_all_selection\window_0
         bsr        uninit_mode
         bsr        init_mode\window_1
         clr.b      window
         cmp.w      #-1,number
         beq.s      change_all_selection\window_0\init_mode
         moveq.b    #1,d5
         bra.s      change_all_selection\window_1

change_all_selection\window_0\init_mode
         bsr        init_mode

change_all_selection\set_bit
         move.w     number(pc),d4
         move.w     d4,d5                        ; save number

change_all_selection\set_bit\loop
         move.w     d4,d1
         bsr        change_selection
         dbf.s      d4,change_all_selection\set_bit\loop

         tst.b      window
         bne.s      change_all_selection\exit

change_all_selection\set_bit\window_0
         bsr        uninit_mode
change_all_selection\set_bit\window_0\folder_loop
         bsr        unalloc_file_list
         move.w     d5,d1                        ; d5 = folder index
         bsr        alloc_file_list\same_folder
         cmp.w      #-1,d1
         beq.s      change_all_selection\set_bit\window_0\folder_loop\dbra
         move.w     d1,d4                        ; d4 = number files
         bsr        init_mode\window_1
change_all_selection\set_bit\window_0\file_loop
         move.w     d4,d1
         bsr        change_selection
         dbf.s      d4,change_all_selection\set_bit\window_0\file_loop
change_all_selection\set_bit\window_0\folder_loop\dbra
         dbf.s      d5,change_all_selection\set_bit\window_0\folder_loop

         bsr        unalloc_file_list
         move.w     current\folder(pc),d1
         bsr        alloc_file_list\same_folder
         bra        init_mode\window_0

change_all_selection\exit
         rts

;============================================================================;
;change_selection                                                            ;
;    Input     : d1.w = variable index                                       ;
;                d7.b = 0 clear, 1 set, 2 invert                             ;
;    Output    : void                                                        ;
;    Destroyed : d0-d2.w,a0-a2.l                                             ;


change_selection\current
         move.w     current(pc),d1

change_selection
         bsr        get_handle
         cmp.b      #1,d7
         beq.s      change_selection\set
         bcs.s      change_selection\clear
change_selection\invert
         bchg.b     #5,11(a2)
         rts
change_selection\set
         bset.b     #5,11(a2)
         rts
change_selection\clear
         bclr.b     #5,11(a2)
         rts

;============================================================================;
;is_selected                                                                 ;
;    Input     : d1.w = variable index                                       ;
;    Output    : void                                                        ;
;    Destroyed : d0-d1.l/a1-a2.l                                             ;

is_selected\current
         move.w     current(pc),d1
is_selected
         bsr        get_handle
         btst.b     #5,11(a2)
         rts

;============================================================================;
;keys                                                                        ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;

keys
         lea        string\keys(pc),a0
         move.w     #keys_window\width,d4
         moveq.w    #keys_window\height,d5
         clr.w      d6
         clr.w      d7
         bsr        dialog_window\open

         lea        string\keys_list(pc),a0
         moveq.w    #keys_window\shortcut\x,d0
         moveq.w    #keys_window\y,d1
         moveq.w    #window_font,d3
         moveq.w    #11,d4
         bra.s      keys\draw

keys\find_string
         tst.b      (a0)+
         bne.s      keys\find_string
         move.b     d4,d5
         and.b      #1,d5
         beq.s      keys\set_shortcut

keys\set_description
         addq.b     #keys_window\dy,d1
         moveq.w    #keys_window\shortcut\x,d0
         bra.s      keys\draw

keys\set_shortcut
         moveq.w    #keys_window\description\x,d0

keys\draw
         bsr        draw_string_a0
         dbf.s      d4,keys\find_string
         bra        dialog_window\pause_and_clear

;============================================================================;
;about                                                                       ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d7.w,a0-a6.l                                             ;

about
         lea        string\about(pc),a0
         moveq.w    #about_window\width,d4
         moveq.w    #about_window\height,d5
         clr.w      d6
         clr.w      d7
         bsr        dialog_window\open

         moveq.w    #about_window\sprite\x,d0
         moveq.w    #about_window\sprite\y,d1
         lea        sprites\logo(pc),a0
         jsr        graphlib::put_sprite

         moveq.w    #window_font,d3
         moveq.w    #about_window\version\x,d0
         moveq.w    #about_window\version\y,d1
         lea        string\about\version(pc),a0
         bsr        draw_string_a0

         moveq.w    #about_window\date\x,d0
         moveq.w    #about_window\date\y,d1
         add.l      #string\about\date-string\about\version,a0
         bsr        draw_string_a0

         moveq.w    #about_window\authors\x,d0
         moveq.w    #about_window\authors\y,d1
         add.l      #string\about\authors-string\about\date,a0
         bsr        draw_string_a0

;         move.w     d6,(a6)     ; !!! ERREUR a6 IMPAIRE !!!

         bra        dialog_window\pause_and_clear

;============================================================================;
;get_password                                                                ;
;    Input     : void                                                        ;
;    Output    : a0.l = address of the entered password                      ;
;                CCR (z=0 wrong password)                                    ;
;    Destroyed : d0-d3.w,a0-a1.l                                             ;

get_password
         tst.b      (userlib::password)              ; no password ?
         beq        get_password\exit
         pea        string\password_protect(pc)
         move.w	    #%0001000000011000,-(a7)         ; title, rounded border,
         pea        dialog_window\pwprotect\size(pc) ; and save screen.
         pea        dialog_window\pwprotect(pc)
         jsr        tios::WinOpen
     ;tst.b     d0
     ;beq	   error                <--- NE PAS OUBLIER
         jsr	    tios::WinActivate
         move.w     #window_font,4(a7)
         jsr        tios::WinFont
         move.w     #6,6(a7)
         move.w     #1,4(a7)
         jsr        tios::DrawStaticButton

         moveq.w    #window_font,d3
         moveq.w    #get_pass_window\enter_pass\x,d0
         moveq.w    #get_pass_window\enter_pass\y,d1
         lea        string\enter_password(pc),a0
         bsr        draw_string_a0

         move.w     #get_pass_window\input_pass\x,d0
         moveq.w    #get_pass_window\input_pass\y,d1
         moveq.w    #10,d2
         clr.w      d3
         move.b     #1,password_protect_flag
         bsr        input_string\empty_field
         clr.b      password_protect_flag

         move.l     a0,a2
         jsr	    tios::WinClose
         move.l     a2,-(a7)
         pea        userlib::password
         jsr        tios::strcmp
         lea        22(a7),a7
	 tst.b	    d0
get_password\exit
         rts

;============================================================================;
;clear_window                                                                ;
;    Input     : void                                                        ;
;    Output    : current window cleared                                      ;
;    Destroyed : d0-d4.w                                                     ;

clear_window
         move.w     window\name_absciss(pc),d0
         subq.b     #6,d0
         moveq.w    #clear\y,d1
         move.w     window\width(pc),d2
         moveq.w    #clear\height,d3
         moveq.w    #1,d4
         jmp        graphlib::fill

;============================================================================;
;invert                                                                      ;
;    Input     : cursor.b                                                    ;
;    Output    : graphics                                                    ;
;    Destroyed : d0,d1,d2,d3,d4                                              ;

invert
         move.w     window\name_absciss(pc),d0
         moveq.w    #draw\y,d1
         move.w     cursor(pc),d2
         lsl.b      #3,d2
         add.b      d2,d1
         moveq.w    #48,d2
         moveq.w    #7,d3
         clr.w      d4
         jmp        graphlib::fill

;============================================================================;
;refresh_indicators                                                          ;
;    Input     : void                                                        ;
;    Output    : indicators drawed                                           ;
;    Destroyed : void                                                        ;

refresh_indicators
         movem.w    d0-d3,-(a7)
         move.l     a0,-(a7)

         move.w     #indicators\x,d0
         moveq.w    #indicators\y,d1

         move.w     #$FF,d3
         lea        sprites\second(pc),a0
         btst.b     #second_bit,indicators_value(pc)
         seq.l      d2
         and.l      #10,d2
         lea        0(a0,d2.l),a0
         jsr        graphlib::put_sprite_mask
         addq.b     #7,d0
         lea        sprites\diamond(pc),a0
         btst.b     #diamond_bit,indicators_value(pc)
         seq.l      d2
         and.l      #10,d2
         lea        0(a0,d2.l),a0
         jsr        graphlib::put_sprite_mask

 ifd ti89
         addq.b     #7,d0
         lea        sprites\alpha(pc),a0
         btst.b     #3,indicators_value(pc)
         seq.l      d2
         and.l      #10,d2
         lea        0(a0,d2.l),a0
         jsr        graphlib::put_sprite_mask
 endc

         move.l     (a7)+,a0
         movem.w    (a7)+,d0-d3
         rts

;============================================================================;
;d0_to_string                                                                ;
;    Input     : d0.l = number to convert to string                          ;
;    Output    : a0.l = address of the string                                ;
;    Destroyed : d0.l                                                        ;

d0_to_string
         move.l     #string+30,a0
         clr.b      (a0)
d0_to_string\loop
         divu       #10,d0
         swap       d0
         add.b      #48,d0
         move.b     d0,-(a0)
         clr.w      d0
         swap       d0
         tst.w      d0
         bne.s      d0_to_string\loop
         rts

;============================================================================;
;draw_string_a0                                                              ;
;    Input     : d0.w = X                                                    ;
;              : d1.w = Y                                                    ;
;              : d3.w = font                                                 ;
;    Output    : a0.l = address of the string                                ;
;    Destroyed : a1.l                                                        ;

draw_string
         lea        string,a0

draw_string_a0
         move.w     #4,-(a7)                 ; Input  d0 : X
         move.l     a0,-(a7)                 ;        d1 : Y
         move.w     d1,-(a7)                 ;        d3 : police
         move.w     d0,-(a7)
         move.w     d3,-(a7)
         jsr        tios::FontSetSys
         addq.l     #2,a7
         jsr        tios::DrawStrXY
         move.w     (a7)+,d0
         move.w     (a7)+,d1
         move.l     (a7)+,a0
         addq.l     #2,a7
         rts

;============================================================================;
;draw_split_line                                                             ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d2.w                                                     ;

draw_split_line
         moveq.w    #split_line\x,d0
         moveq.w    #split_line\y,d1
         moveq.w    #split_line\height,d2
         jmp        graphlib::vert

;============================================================================;
;save_all_screen                                                             ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : d0-d4.w                                                     ;

save_all_screen
         movem.w    d0-d4,-(a7)
         clr.w      d0
         clr.w      d1
         moveq.w    #lcd_width/8,d2
         move.w     #lcd_height,d3
         jsr        graphlib::scrtomem
        ;tst.w      d4
        ;beq        error                   <---- Ne pas oublier
         move.w     d4,handle\saved_screen
         movem.w    (a7)+,d0-d4
         rts

;============================================================================;
;restore_all_screen                                                          ;
;    Input     : void                                                        ;
;    Output    : void                                                        ;
;    Destroyed : void                                                        ;

restore_all_screen
         movem.w    d0-d4,-(a7)
         clr.w      d0
         clr.w      d1
         moveq.w    #lcd_width/8,d2
         move.w     #lcd_height,d3
         move.w     handle\saved_screen(pc),d4
         jsr        graphlib::memtoscr
         movem.w    (a7)+,d0-d4
         rts

;============================================================================;
;batteries_level                                                             ;

batteries_level
         moveq.w    #4,d2
         movea.l    #$600018,a0

batteries_level\loop_1
         move.w     #$380,(a0)
         move.w     #$52,d0

batteries_level\loop_2
         btst.l     #2,($600000)
         dbne.s     d0,batteries_level\loop_2
         moveq.w    #4,d0               ;
         sub.w      d2,d0               ; d0 = {$000,$080,$100,$180,$200}
         lsl.w      #7,d0               ;
         move.w     d0,(a0)
         move.w     #$6E,d0

batteries_level\loop_3
         btst.l     #2,($600000)
         dbeq.s     d0,batteries_level\loop_3
         bne.s      batteries_level\exit
         dbf.s      d2,batteries_level\loop_1

batteries_level\exit
         addq.b     #1,d2               ; 0 <= d2.w <= 5
         rts


;                                  misc.asm                                  ;
;============================================================================;