;============================================================================;
;                                 system.asm                                 ;

system\interrupts_off
         move.l     ($64),system\old_handler_1
         move.l     ($68),system\old_handler_2
         move.l     ($6C),system\old_handler_3
         move.l     ($70),system\old_handler_4
         move.l     ($74),system\old_handler_5
         move.l     ($78),system\old_handler_6
         move.l     ($7C),system\old_handler_7
         move.l     #system\null_interrupt_handler,($40064)
         move.l     #system\null_interrupt_handler,($40068)
         move.l     #system\null_interrupt_handler,($4006C)
         move.l     #system\null_interrupt_handler,($40070)
         move.l     #system\handler_5,($40074)
         move.l     #system\null_interrupt_handler,($40078)
         move.l     #system\null_interrupt_handler,($4007C)
         rts

system\interrupts_on
         move.l     system\old_handler_1(pc),($40064)
         move.l     system\old_handler_2(pc),($40068)
         move.l     system\old_handler_3(pc),($4006C)
         move.l     system\old_handler_4(pc),($40070)
         move.l     system\old_handler_5(pc),($40074)
         move.l     system\old_handler_6(pc),($40078)
         move.l     system\old_handler_7(pc),($4007C)
         rts

system\partial_interrupts_off
         move.l     #system\null_interrupt_handler,($40064)
         move.l     #system\null_interrupt_handler,($40068)
         move.l     #system\null_interrupt_handler,($4006C)
         move.l     #system\null_interrupt_handler,($40070)
         move.l     #system\handler_5,($40074)
         move.l     #system\null_interrupt_handler,($40078)
         move.l     #system\null_interrupt_handler,($4007C)
         rts

system\partial_interrupts_on
         move.l     system\old_handler_1(pc),($40064)
         move.l     system\old_handler_2(pc),($40068)
         move.l     system\old_handler_3(pc),($4006C)
         move.l     system\old_handler_4(pc),($40070)
         move.l     system\old_handler_5(pc),($40074)
         move.l     system\old_handler_6(pc),($40078)
         move.l     system\old_handler_7(pc),($4007C)
         rts

system\handler_5
         addq.l     #1,apd\calls_5
         addq.l     #1,timer_20
         addq.l     #1,timer_20_2
         movem.l    d0-d1,-(a7)
         jsr        userlib::get_APD
         move.l     d0,d1
         lsl.l      #2,d1
         lsl.l      #4,d0
         add.l      d1,d0
         sub.l      apd\calls_5(pc),d0
         sle.b      apd\shut_down_if_idle
         movem.l    (a7)+,d0-d1
         rte

system\null_interrupt_handler
         rte

;                                 system.asm                                 ;
;============================================================================;