;============================================================================;
;                                  tex.asm                                   ;
;============================================================================;

;ti92plus                       ; comment out to compile for the TI92+

 ifnd ti92plus
ti89
 endc

 include "globals.h"

 include "tios.h"

 include "graphlib.h"

 include "filelib.h"

 include "userlib.h"

 include "viewlib.h"

 include "ziplib.h"

 xdef _main

 xdef _exit

 xdef _comment

 ifd ti89
 xdef _ti89
 endc

 ifd ti92plus
 xdef _ti92plus
 endc

_main
         bsr        system\interrupts_off
         bsr        init\program
         bsr        wait_for_no_key

         btst.b     #0,shell_bolt_flag
         beq.s      no_shell_bolt
         bsr        get_password
         beq.s      no_shell_bolt
         bra        _exit
no_shell_bolt

main_loop

         bsr        draw_info

main_loop\wait_for_a_key

         btst.b     #select_bit,old_indicators(pc)
         bne.s      main_loop\test_if_key_pressed
         bsr        selection

main_loop\test_if_key_pressed

         btst.b     #select_bit,old_indicators(pc)
         seq.b      shift_flag

         bsr        get_key
         tst.w      d6
         beq.b      main_loop\wait_for_a_key

         move.b     menu\number,d0
	 pea        main_loop(pc)

main_loop\test_esc
         cmp.w      #264,d6
         beq        main_loop\esc

main_loop\test_enter
         cmp.w      #13,d6
         beq        main_loop\enter

main_loop\test_up_and_down
         cmp.w      #338,d6
         beq        main_loop\up
         cmp.w      #4434,d6
         beq        main_loop\up\second
         cmp.w      #8530,d6
         beq        main_loop\up\diamond
         cmp.w      #344,d6
         beq        main_loop\down
         cmp.w      #4440,d6
         beq        main_loop\down\second
         cmp.w      #8536,d6
         beq        main_loop\down\diamond

main_loop\test_left_and_right
         cmp.w      #337,d6
         beq        main_loop\right
         cmp.w      #340,d6
         beq        main_loop\left

main_loop\test_f1_to_f5
         cmp.w      #268,d6
         bcs.s      main_loop\not_f1_to_f5
         cmp.w      #272,d6
         bhi.s      main_loop\not_f1_to_f5
         bra        main_loop\f1_to_f5
main_loop\not_f1_to_f5

main_loop\test_a_to_z
         cmp.w      #97,d6
         bcs.s      main_loop\not_a_to_z
         cmp.w      #122,d6
         bhi.s      main_loop\not_a_to_z
         bra        main_loop\a_to_z
main_loop\not_a_to_z

main_loop\test_1_to_9
         cmp.w      #49,d6
         bcs.s      main_loop\not_1_to_9
         cmp.w      #57,d6
         bhi.s      main_loop\not_1_to_9
         bra        main_loop\1_to_9
main_loop\not_1_to_9

main_loop\shortcuts
         lea        shortcut_table(pc),a0
         moveq.w    #64,d0
main_loop\shortcut\loop
         cmp.w      (a0)+,d6
         dbeq.s     d0,main_loop\shortcut\loop
         cmp.w      #-1,d0
         beq.s      main_loop\shortcut\exit
         moveq.b    #64,d7
         sub.b      d0,d7
         move.b     d7,d6
         lsr.b      #4,d6
         and.l      #$F,d6
         and.l      #$F,d7
         bra        menu\call_sub_routine_2
main_loop\shortcut\exit
         rts

main_loop\esc
         cmp.b      #$FF,d0
         beq        main_loop\exit
         move.b     indicators_saved_value(pc),d0
         move.b     d0,indicators_value
         move.b     #1,indicators_clear_flag
         bra        menu\clear

main_loop\enter
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\enter
         bra        execute
main_loop\menu\enter
         bra        menu\call_sub_routine

main_loop\up
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\up
         bra        move\up
main_loop\menu\up
         bra        menu\move\up

main_loop\up\second
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\up\second
         bra        move\up\second
main_loop\menu\up\second
         bra        menu\move\go_to_top

main_loop\up\diamond
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\up\diamond
         bra        move\go_to_top
main_loop\menu\up\diamond
         bra        menu\move\go_to_top

main_loop\down
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\down
         bra        move\down
main_loop\menu\down
         bra        menu\move\down

main_loop\down\second
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\down\second
         bra        move\down\second
main_loop\menu\down\second
         bra        menu\move\go_to_bottom

main_loop\down\diamond
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\down\diamond
         bra        move\go_to_bottom
main_loop\menu\down\diamond
         bra        menu\move\go_to_bottom

main_loop\left
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\left
         bra        switch\left
main_loop\menu\left
         bra        menu\switch\left

main_loop\right
         cmp.b      #$FF,d0
         bne.s      main_loop\menu\right
         bra        switch\right
main_loop\menu\right
         bra        menu\switch\right

main_loop\f1_to_f5
         bra        menu\open

main_loop\a_to_z
         bsr        menu\clear
         bra        move\a_to_z

main_loop\1_to_9
         cmp.b      #$FF,d0
         bne        main_loop\menu\1_to_9
         rts
main_loop\menu\1_to_9
         bra        menu\1_to_9_shortcut

main_loop\exit
         addq.l     #4,a7

_exit
         bsr        uninit_mode
         bsr        unalloc_file_list
         bsr        unalloc_folder_list
         bsr        system\interrupts_on
         jsr        tios::reset_link
         clr.w      tios::kb_vars+$1C
         rts

 include "dialog.asm"

 include "errors.asm"

 include "execute.asm"

 include "file.asm"

 include "init.asm"

 include "inputstr.asm"

 include "keyboard.asm"

 include "menu.asm"

 include "misc.asm"

 include "move.asm"

 include "setup.asm"

 include "system.asm"

 include "vat.asm"

 include "data.asm"

 end

;============================================================================;
;                                  tex.asm                                   ;
;============================================================================;